﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
#IgnoreWarnings:12
#Event: DidDismiss (e As BANanoEvent)
#Event: DidPresent (e As BANanoEvent)
#Event: IonBreakpointDidChange (e As BANanoEvent)
#Event: IonModalDidDismiss (e As BANanoEvent)
#Event: IonModalDidPresent (e As BANanoEvent)
#Event: IonModalWillDismiss (e As BANanoEvent)
#Event: IonModalWillPresent (e As BANanoEvent)
#Event: WillDismiss (e As BANanoEvent)
#Event: WillPresent (e As BANanoEvent)
#DesignerProperty: Key: Animated, DisplayName: Animated, FieldType: Boolean, DefaultValue: True, Description: Animated
#DesignerProperty: Key: BackdropBreakpoint, DisplayName: Backdrop Breakpoint, FieldType: String, DefaultValue: 0, Description: Backdrop Breakpoint
#DesignerProperty: Key: BackdropDismiss, DisplayName: Backdrop Dismiss, FieldType: Boolean, DefaultValue: True, Description: Backdrop Dismiss
#DesignerProperty: Key: Breakpoints, DisplayName: Breakpoints, FieldType: String, DefaultValue: , Description: Breakpoints
#DesignerProperty: Key: CanDismiss, DisplayName: Can Dismiss, FieldType: Boolean, DefaultValue: True, Description: Can Dismiss
#DesignerProperty: Key: EnterAnimation, DisplayName: Enter Animation, FieldType: String, DefaultValue: , Description: Enter Animation
#DesignerProperty: Key: Handle, DisplayName: Handle, FieldType: String, DefaultValue: , Description: Handle
#DesignerProperty: Key: HandleBehavior, DisplayName: Handle Behavior, FieldType: String, DefaultValue: none, Description: Handle Behavior, List: cycle|none
#DesignerProperty: Key: InitialBreakpoint, DisplayName: Initial Breakpoint, FieldType: String, DefaultValue: , Description: Initial Breakpoint
#DesignerProperty: Key: IsOpen, DisplayName: Is Open, FieldType: Boolean, DefaultValue: False, Description: Is Open
#DesignerProperty: Key: KeepContentsMounted, DisplayName: Keep Contents Mounted, FieldType: Boolean, DefaultValue: False, Description: Keep Contents Mounted
#DesignerProperty: Key: KeyboardClose, DisplayName: Keyboard Close, FieldType: Boolean, DefaultValue: True, Description: Keyboard Close
#DesignerProperty: Key: LeaveAnimation, DisplayName: Leave Animation, FieldType: String, DefaultValue: , Description: Leave Animation
#DesignerProperty: Key: Mode, DisplayName: Mode, FieldType: String, DefaultValue: ios, Description: Mode, List: ios|md
#DesignerProperty: Key: PresentingElement, DisplayName: Presenting Element, FieldType: String, DefaultValue: , Description: Presenting Element
#DesignerProperty: Key: ShowBackdrop, DisplayName: Show Backdrop, FieldType: Boolean, DefaultValue: True, Description: Show Backdrop
#DesignerProperty: Key: Trigger, DisplayName: Trigger, FieldType: String, DefaultValue: , Description: Trigger
#DesignerProperty: Key: Visible, DisplayName: Visible, FieldType: Boolean, DefaultValue: True, Description: If visible.
Sub Class_Globals
    Public CustProps As Map 'ignore
    Private mCallBack As Object 'ignore
    Private mEventName As String 'ignore
    Private mElement As BANanoElement 'ignore
    Private mTarget As BANanoElement 'ignore
    Private mName As String 'ignore
    Private BANano As BANano   'ignore
    Private mVisible As Boolean = True
    Private sText As String = ""
    Public Tag As Object
    Private bAnimated As Boolean = True
    Private sBackdropBreakpoint As String = "0"
    Private bBackdropDismiss As Boolean = True
    Private sBackdropOpacity As String = ""
    Private sBackground As String = ""
    Private sBorderColor As String = ""
    Private sBorderRadius As String = ""
    Private sBorderStyle As String = ""
    Private sBorderWidth As String = ""
    Private sBreakpoints As String = ""
    Private bCanDismiss As Boolean = True
    Private sEnterAnimation As String = ""
    Private sHandle As String = ""
    Private sHandleBehavior As String = "none"
    Private sHeight As String = ""
    Private htmlAttributes As Map
    Private sInitialBreakpoint As String = ""
    Private bIsOpen As Boolean = False
    Private bKeepContentsMounted As Boolean = False
    Private bKeyboardClose As Boolean = True
    Private sLeaveAnimation As String = ""
    Private sMaxHeight As String = ""
    Private sMaxWidth As String = ""
    Private sMinHeight As String = ""
    Private sMinWidth As String = ""
    Private sMode As String = "ios"
    Private sPresentingElement As String = ""
    Private bShowBackdrop As Boolean = True
    Private sTrigger As String = ""
    Private sWidth As String = ""
    Public CONST HANDLEBEHAVIOR_CYCLE As String = "cycle"
    Public CONST HANDLEBEHAVIOR_NONE As String = "none"
End Sub
Public Sub Initialize (Callback As Object, Name As String, EventName As String)
    mEventName = SDUIShared.CleanID(EventName)
    mName = SDUIShared.CleanID(Name)
    mCallBack = Callback
    htmlAttributes.Initialize
End Sub
' returns the BANanoElement
Public Sub getElement() As BANanoElement
    Return mElement
End Sub
' returns the element id
Public Sub getID() As String
    Return mName
End Sub
Public Sub AddToParent(targetID As String, props As Map)
    targetID = SDUIShared.CleanID(targetID)
    mTarget = BANano.GetElement("#" & targetID)
    DesignerCreateView(mTarget, props)
End Sub
Public Sub Remove()
    mElement.Remove
    BANano.SetMeToNull
End Sub
Sub setElement(e As BANanoElement)
    mElement = e
End Sub
Sub LinkExisting
    mElement.Initialize($"${mName}"$)
End Sub
Public Sub TriggerEvent(event As String, params() As String)
    If mElement <> Null Then
        mElement.Trigger(event, params)
    End If
End Sub
Public Sub getHere() As String
    Return $"#${mName}"$
End Sub
Sub SetAttr(attr As String, text As String)
    If mElement <> Null Then mElement.SetAttr(attr, text)
End Sub
Sub SetDataAttr(attr As String, text As String)
    If mElement <> Null Then mElement.SetData(attr, text)
End Sub
Sub GetDataAttr(attr As String) As String
    If mElement <> Null Then
        Dim text As String = mElement.GetData(attr)
        Return text
    Else
        Return ""
    End If
End Sub
Sub GetAttr(attr As String) As String
    If mElement <> Null Then
        Dim text As String = mElement.GetAttr(attr)
        Return text
    Else
        Return ""
    End If
End Sub
Sub AddClass(text As String)
    If mElement <> Null Then
        Dim lst As List = SDUIShared.StrParse(" ", text)
        For Each c As String In lst
            mElement.AddClass(c)
        Next
    End If
End Sub
Sub RemoveClass(text As String)
    If mElement <> Null Then
        Dim lst As List = SDUIShared.StrParse(" ", text)
        For Each c As String In lst
            mElement.RemoveClass(c)
        Next
    End If
End Sub
Sub AddAttr(ms As Map)
    If ms.Size = 0 Then Return
    For Each k As String In ms.Keys
        Dim v As String = ms.Get(k)
        SetAttr(k, v)
    Next
End Sub
Sub RemoveAttr(attr As String)
    If mElement <> Null Then
        mElement.RemoveAttr(attr)
    End If
End Sub
Sub AddStyleComputed(attr As String, text As String)
    If mElement <> Null Then
        mElement.GetField("style").RunMethod("setProperty", Array(attr, text))
    End If
End Sub
Sub AddStyle(ms As Map)
    If ms.Size = 0 Then Return
    If mElement <> Null Then
        mElement.SetStyle(BANano.ToJson(ms))
    End If
End Sub
'set Visible
Sub setVisible(b As Boolean)
    mVisible = b
    If b Then
        RemoveClass("ion-hide")
    Else
        AddClass("ion-hide")
    End If
End Sub
'get Visible
Sub getVisible As Boolean
    Return mVisible
End Sub
Sub On(event As String, args As List)
    event = event.Replace(":","")
    event = event.Replace(".","")
    event = event.Replace("-","")
    '
    Dim methodName As String = $"${mEventName}_${event}"$
    '
    If SubExists(mCallBack, methodName) = False Then Return
    Dim cb As BANanoObject
    cb = BANano.CallBack(mCallBack, methodName, BANano.Spread(args))
    mElement.AddEventListener(event, cb, True)
End Sub
Sub OnInternal(event As String, methodName As String, args As List)
    event = event.Replace(":","")
    event = event.Replace(".","")
    event = event.Replace("-","")
    '
    If SubExists(Me, methodName) = False Then Return
    Dim cb As BANanoObject
    cb = BANano.CallBack(Me, methodName, BANano.Spread(args))
    mElement.AddEventListener(event, cb, True)
End Sub
'Private Sub ionChange(e As BANanoEvent)
'Dim value As String = e.OtherField("detail").GetField("value").Result
'value = SDUIShared.CStr(value)
'BANano.CallSub(mCallBack, $"${mName}_ionChange"$, Array(value))
'End Sub
Public Sub DesignerCreateView (Target As BANanoElement, Props As Map)
    CustProps = Props
    mTarget = Target
    If Props <> Null Then
        mVisible = Props.GetDefault("Visible", True)
        mVisible = SDUIShared.parseBool(mVisible)
        bAnimated = Props.GetDefault("Animated", True)
        bAnimated = SDUIShared.CBool(bAnimated)
        sBackdropBreakpoint = Props.GetDefault("BackdropBreakpoint", "0")
        sBackdropBreakpoint = SDUIShared.CStr(sBackdropBreakpoint)
        If sBackdropBreakpoint = "0" Then sBackdropBreakpoint = ""
        bBackdropDismiss = Props.GetDefault("BackdropDismiss", True)
        bBackdropDismiss = SDUIShared.CBool(bBackdropDismiss)
        sBreakpoints = Props.GetDefault("Breakpoints", "")
        sBreakpoints = SDUIShared.CStr(sBreakpoints)
        bCanDismiss = Props.GetDefault("CanDismiss", True)
        bCanDismiss = SDUIShared.CBool(bCanDismiss)
        sEnterAnimation = Props.GetDefault("EnterAnimation", "")
        sEnterAnimation = SDUIShared.CStr(sEnterAnimation)
        sHandle = Props.GetDefault("Handle", "")
        sHandle = SDUIShared.CStr(sHandle)
        sHandleBehavior = Props.GetDefault("HandleBehavior", "none")
        sHandleBehavior = SDUIShared.CStr(sHandleBehavior)
        If sHandleBehavior = "none" Then sHandleBehavior = ""
        sInitialBreakpoint = Props.GetDefault("InitialBreakpoint", "")
        sInitialBreakpoint = SDUIShared.CStr(sInitialBreakpoint)
        bIsOpen = Props.GetDefault("IsOpen", False)
        bIsOpen = SDUIShared.CBool(bIsOpen)
        bKeepContentsMounted = Props.GetDefault("KeepContentsMounted", False)
        bKeepContentsMounted = SDUIShared.CBool(bKeepContentsMounted)
        bKeyboardClose = Props.GetDefault("KeyboardClose", True)
        bKeyboardClose = SDUIShared.CBool(bKeyboardClose)
        sLeaveAnimation = Props.GetDefault("LeaveAnimation", "")
        sLeaveAnimation = SDUIShared.CStr(sLeaveAnimation)
        sMode = Props.GetDefault("Mode", "ios")
        sMode = SDUIShared.CStr(sMode)
        If sMode = "ios" Then sMode = ""
        sPresentingElement = Props.GetDefault("PresentingElement", "")
        sPresentingElement = SDUIShared.CStr(sPresentingElement)
        bShowBackdrop = Props.GetDefault("ShowBackdrop", True)
        bShowBackdrop = SDUIShared.CBool(bShowBackdrop)
        sTrigger = Props.GetDefault("Trigger", "")
        sTrigger = SDUIShared.CStr(sTrigger)
        sTrigger = sTrigger.ToLowerCase
    End If
    '
    Dim se As SithasoElement
    se.Initialize
    If bAnimated <> True Then se.AddAttr("animated", bAnimated)
    If sBackdropBreakpoint <> "0" Then se.AddAttr("backdrop-breakpoint", sBackdropBreakpoint)
    If bBackdropDismiss <> True Then se.AddAttr("backdrop-dismiss", bBackdropDismiss)
    If sBreakpoints <> "" Then se.AddAttr("breakpoints", sBreakpoints)
    If bCanDismiss <> True Then se.AddAttr("can-dismiss", bCanDismiss)
    If sEnterAnimation <> "" Then se.AddAttr("enter-animation", sEnterAnimation)
    If sHandle <> "" Then se.AddAttr("handle", sHandle)
    If sHandleBehavior <> "none" Then se.AddAttr("handle-behavior", sHandleBehavior)
    If sInitialBreakpoint <> "" Then se.AddAttr("initial-breakpoint", sInitialBreakpoint)
    If bIsOpen <> False Then se.AddAttr("is-open", bIsOpen)
    If bKeepContentsMounted <> False Then se.AddAttr("keep-contents-mounted", bKeepContentsMounted)
    If bKeyboardClose <> True Then se.AddAttr("keyboard-close", bKeyboardClose)
    If sLeaveAnimation <> "" Then se.AddAttr("leave-animation", sLeaveAnimation)
    If sMode <> "ios" Then se.AddAttr("mode", sMode)
    If sPresentingElement <> "" Then se.AddAttr("presenting-element", sPresentingElement)
    If bShowBackdrop <> True Then se.AddAttr("show-backdrop", bShowBackdrop)
    If sTrigger <> "" Then se.AddAttr("trigger", sTrigger)
    se.BuildAttr
    mElement = mTarget.Append($"[BANCLEAN]<ion-modal id="${mName}" ${se.exAttrs} ${se.exAttrs1}>${sText}</ion-modal>"$).Get("#" & mName)
    If sBackdropOpacity <> "" Then AddStyleComputed("--backdrop-opacity", sBackdropOpacity)
    If sBackground <> "" Then AddStyleComputed("--background", sBackground)
    If sBorderColor <> "" Then AddStyleComputed("--border-color", sBorderColor)
    If sBorderRadius <> "" Then AddStyleComputed("--border-radius", sBorderRadius)
    If sBorderStyle <> "" Then AddStyleComputed("--border-style", sBorderStyle)
    If sBorderWidth <> "" Then AddStyleComputed("--border-width", sBorderWidth)
    If sHeight <> "" Then AddStyleComputed("--height", sHeight)
    If sMaxHeight <> "" Then AddStyleComputed("--max-height", sMaxHeight)
    If sMaxWidth <> "" Then AddStyleComputed("--max-width", sMaxWidth)
    If sMinHeight <> "" Then AddStyleComputed("--min-height", sMinHeight)
    If sMinWidth <> "" Then AddStyleComputed("--min-width", sMinWidth)
    If sWidth <> "" Then AddStyleComputed("--width", sWidth)
    If mVisible = False Then setVisible(mVisible)
    On("didDismiss", Array("e"))
    On("didPresent", Array("e"))
    On("ionBreakpointDidChange", Array("e"))
    On("ionModalDidDismiss", Array("e"))
    On("ionModalDidPresent", Array("e"))
    On("ionModalWillDismiss", Array("e"))
    On("ionModalWillPresent", Array("e"))
    On("willDismiss", Array("e"))
    On("willPresent", Array("e"))
End Sub
Sub dismiss() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("dismiss", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
Sub getCurrentBreakpoint() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("getCurrentBreakpoint", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
Sub onDidDismiss() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("onDidDismiss", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
Sub onWillDismiss() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("onWillDismiss", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
Sub present() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("present", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
Sub setCurrentBreakpoint() As BANanoPromise
    If mElement <> Null Then
        Dim bp As BANanoPromise = mElement.RunMethod("setCurrentBreakpoint", Array())
        Return bp
    Else
        Return Null
    End If
End Sub
'set Animated
Sub setAnimated(b As Boolean)
    bAnimated = b
    If mElement <> Null Then
        If b <> True Then
            mElement.SetAttr("animated", b)
        Else
            mElement.RemoveAttr("animated")
        End If
    End If
End Sub
'set Backdrop Breakpoint
Sub setBackdropBreakpoint(s As String)
    sBackdropBreakpoint = s
    If mElement <> Null Then
        mElement.SetAttr("backdrop-breakpoint", s)
    End If
End Sub
'set Backdrop Dismiss
Sub setBackdropDismiss(b As Boolean)
    bBackdropDismiss = b
    If mElement <> Null Then
        If b <> True Then
            mElement.SetAttr("backdrop-dismiss", b)
        Else
            mElement.RemoveAttr("backdrop-dismiss")
        End If
    End If
End Sub
'set Backdrop Opacity
Sub setBackdropOpacity(s As String)
    sBackdropOpacity = s
    AddStyleComputed("--backdrop-opacity", s)
End Sub
'set Background
Sub setBackground(s As String)
    sBackground = s
    AddStyleComputed("--background", s)
End Sub
'set Border Color
Sub setBorderColor(s As String)
    sBorderColor = s
    AddStyleComputed("--border-color", s)
End Sub
'set Border Radius
Sub setBorderRadius(s As String)
    sBorderRadius = s
    AddStyleComputed("--border-radius", s)
End Sub
'set Border Style
Sub setBorderStyle(s As String)
    sBorderStyle = s
    AddStyleComputed("--border-style", s)
End Sub
'set Border Width
Sub setBorderWidth(s As String)
    sBorderWidth = s
    AddStyleComputed("--border-width", s)
End Sub
'set Breakpoints
Sub setBreakpoints(s As String)
    sBreakpoints = s
    If mElement <> Null Then
        mElement.SetAttr("breakpoints", s)
    End If
End Sub
'set Can Dismiss
Sub setCanDismiss(b As Boolean)
    bCanDismiss = b
    If mElement <> Null Then
        If b <> True Then
            mElement.SetAttr("can-dismiss", b)
        Else
            mElement.RemoveAttr("can-dismiss")
        End If
    End If
End Sub
'set Enter Animation
Sub setEnterAnimation(s As String)
    sEnterAnimation = s
    If mElement <> Null Then
        mElement.SetAttr("enter-animation", s)
    End If
End Sub
'set Handle
Sub setHandle(s As String)
    sHandle = s
    If mElement <> Null Then
        mElement.SetAttr("handle", s)
    End If
End Sub
'set Handle Behavior
'options: cycle|none
Sub setHandleBehavior(s As String)
    sHandleBehavior = s
    If mElement <> Null Then
        mElement.SetAttr("handle-behavior", s)
    End If
End Sub
'set Height
Sub setHeight(s As String)
    sHeight = s
    AddStyleComputed("--height", s)
End Sub
'set Html Attributes
Sub setHtmlAttributes(s As Map)
    htmlAttributes = s
    If mElement <> Null Then
        mElement.SetField("htmlAttributes", s)
    End If
End Sub
'set Initial Breakpoint
Sub setInitialBreakpoint(s As String)
    sInitialBreakpoint = s
    If mElement <> Null Then
        mElement.SetAttr("initial-breakpoint", s)
    End If
End Sub
'set Is Open
Sub setIsOpen(b As Boolean)
    bIsOpen = b
    If mElement <> Null Then
        If b <> False Then
            mElement.SetAttr("is-open", b)
        Else
            mElement.RemoveAttr("is-open")
        End If
    End If
End Sub
'set Keep Contents Mounted
'Sub setKeepContentsMounted(b As Boolean)
'    bKeepContentsMounted = b
'    If mElement <> Null Then
'        If b <> False Then
'            mElement.SetAttr("keep-contents-mounted", b)
'        Else
'            mElement.RemoveAttr("keep-contents-mounted")
'        End If
'    End If
'End Sub
'set Keyboard Close
Sub setKeyboardClose(b As Boolean)
    bKeyboardClose = b
    If mElement <> Null Then
        If b <> True Then
            mElement.SetAttr("keyboard-close", b)
        Else
            mElement.RemoveAttr("keyboard-close")
        End If
    End If
End Sub
'set Leave Animation
Sub setLeaveAnimation(s As String)
    sLeaveAnimation = s
    If mElement <> Null Then
        mElement.SetAttr("leave-animation", s)
    End If
End Sub
'set Max Height
Sub setMaxHeight(s As String)
    sMaxHeight = s
    AddStyleComputed("--max-height", s)
End Sub
'set Max Width
Sub setMaxWidth(s As String)
    sMaxWidth = s
    AddStyleComputed("--max-width", s)
End Sub
'set Min Height
Sub setMinHeight(s As String)
    sMinHeight = s
    AddStyleComputed("--min-height", s)
End Sub
'set Min Width
Sub setMinWidth(s As String)
    sMinWidth = s
    AddStyleComputed("--min-width", s)
End Sub
'set Mode
'options: ios|md
Sub setMode(s As String)
    sMode = s
    If mElement <> Null Then
        mElement.SetAttr("mode", s)
    End If
End Sub
'set Presenting Element
Sub setPresentingElement(s As String)
    sPresentingElement = s
    If mElement <> Null Then
        mElement.SetAttr("presenting-element", s)
    End If
End Sub
'set Show Backdrop
Sub setShowBackdrop(b As Boolean)
    bShowBackdrop = b
    If mElement <> Null Then
        If b <> True Then
            mElement.SetAttr("show-backdrop", b)
        Else
            mElement.RemoveAttr("show-backdrop")
        End If
    End If
End Sub
'set Trigger
Sub setTrigger(s As String)
    s = s.ToLowerCase
    sTrigger = s
    If mElement <> Null Then
        mElement.SetAttr("trigger", s)
    End If
End Sub
'set Width
Sub setWidth(s As String)
    sWidth = s
    AddStyleComputed("--width", s)
End Sub
'get Animated
Sub getAnimated As Boolean
    Return bAnimated
End Sub
'get Backdrop Breakpoint
Sub getBackdropBreakpoint As String
    Return sBackdropBreakpoint
End Sub
'get Backdrop Dismiss
Sub getBackdropDismiss As Boolean
    return bBackdropDismiss
End Sub
'get Backdrop Opacity
Sub getBackdropOpacity As String
    return sBackdropOpacity
End Sub
'get Background
Sub getBackground As String
    return sBackground
End Sub
'get Border Color
Sub getBorderColor As String
    return sBorderColor
End Sub
'get Border Radius
Sub getBorderRadius As String
    return sBorderRadius
End Sub
'get Border Style
Sub getBorderStyle As String
    return sBorderStyle
End Sub
'get Border Width
Sub getBorderWidth As String
    return sBorderWidth
End Sub
'get Breakpoints
Sub getBreakpoints As String
    return sBreakpoints
End Sub
'get Can Dismiss
Sub getCanDismiss As Boolean
    Return bCanDismiss
End Sub
'get Enter Animation
Sub getEnterAnimation As String
    Return sEnterAnimation
End Sub
'get Handle
Sub getHandle As String
    Return sHandle
End Sub
'get Handle Behavior
Sub getHandleBehavior As String
    Return sHandleBehavior
End Sub
'get Height
Sub getHeight As String
    Return sHeight
End Sub
'get Html Attributes
Sub getHtmlAttributes As Map
    Return htmlAttributes
End Sub
'get Initial Breakpoint
Sub getInitialBreakpoint As String
    Return sInitialBreakpoint
End Sub
'get Is Open
Sub getIsOpen As Boolean
    Return bIsOpen
End Sub
'get Keep Contents Mounted
'Sub getKeepContentsMounted As Boolean
'    Return bKeepContentsMounted
'End Sub
'get Keyboard Close
Sub getKeyboardClose As Boolean
    Return bKeyboardClose
End Sub
'get Leave Animation
Sub getLeaveAnimation As String
    Return sLeaveAnimation
End Sub
'get Max Height
Sub getMaxHeight As String
    Return sMaxHeight
End Sub
'get Max Width
Sub getMaxWidth As String
    Return sMaxWidth
End Sub
'get Min Height
Sub getMinHeight As String
    Return sMinHeight
End Sub
'get Min Width
Sub getMinWidth As String
    Return sMinWidth
End Sub
'get Mode
Sub getMode As String
    Return sMode
End Sub
'get Presenting Element
Sub getPresentingElement As String
    Return sPresentingElement
End Sub
'get Show Backdrop
Sub getShowBackdrop As Boolean
    Return bShowBackdrop
End Sub
'get Trigger
Sub getTrigger As String
    Return sTrigger
End Sub
'get Width
Sub getWidth As String
    Return sWidth
End Sub
